/* A Bison parser, made by GNU Bison 2.3.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.3"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     SEC_DIR = 258,
     TEXT_DIR = 259,
     DATA_DIR = 260,
     WORD_DIR = 261,
     BYTE_DIR = 262,
     ASCII_DIR = 263,
     GLOBAL_DIR = 264,
     SKIP_DIR = 265,
     END_DIR = 266,
     LPAREN = 267,
     RPAREN = 268,
     LBR = 269,
     RBR = 270,
     GOTO = 271,
     COMMA = 272,
     COLLON = 273,
     PUTPAR = 274,
     GETPAR = 275,
     RETURN = 276,
     CALL = 277,
     JUMP = 278,
     PLUS = 279,
     MINUS = 280,
     TIMES = 281,
     DIV = 282,
     LOG_AND = 283,
     LOG_OR = 284,
     LOG_NOT = 285,
     BIT_AND = 286,
     BIT_OR = 287,
     BIT_NOT = 288,
     PHI = 289,
     ATRIB = 290,
     ID = 291,
     IVAL = 292,
     DVAL = 293,
     CVAL = 294,
     SVAL = 295,
     NL = 296,
     LT = 297,
     GT = 298,
     LE = 299,
     GE = 300,
     EQ = 301,
     NEQ = 302,
     IF = 303,
     HALT = 304,
     NOP = 305
   };
#endif
/* Tokens.  */
#define SEC_DIR 258
#define TEXT_DIR 259
#define DATA_DIR 260
#define WORD_DIR 261
#define BYTE_DIR 262
#define ASCII_DIR 263
#define GLOBAL_DIR 264
#define SKIP_DIR 265
#define END_DIR 266
#define LPAREN 267
#define RPAREN 268
#define LBR 269
#define RBR 270
#define GOTO 271
#define COMMA 272
#define COLLON 273
#define PUTPAR 274
#define GETPAR 275
#define RETURN 276
#define CALL 277
#define JUMP 278
#define PLUS 279
#define MINUS 280
#define TIMES 281
#define DIV 282
#define LOG_AND 283
#define LOG_OR 284
#define LOG_NOT 285
#define BIT_AND 286
#define BIT_OR 287
#define BIT_NOT 288
#define PHI 289
#define ATRIB 290
#define ID 291
#define IVAL 292
#define DVAL 293
#define CVAL 294
#define SVAL 295
#define NL 296
#define LT 297
#define GT 298
#define LE 299
#define GE 300
#define EQ 301
#define NEQ 302
#define IF 303
#define HALT 304
#define NOP 305




/* Copy the first part of user declarations.  */
#line 1 "assem.y"

/* **************************************************************************** */
/*                                                                              */
/*  Copyright (c) 2011 University of Southern California (USC)                  */ 
/*                                                                              */
/*  All rights reserved.                                                        */
/*                                                                              */
/*  Permission is given to use, copy, and modify this software for any          */
/*  non-commercial purpose as long as this copyright notice is not removed      */
/*  All other uses, including redistribution in whole or in part, are           */
/*  forbidden without prior written permission.                                 */
/*                                                                              */
/*  This software is provided with absolutely no warranty and no support.       */
/*                                                                              */
/*  For further information contact: pedro@isi.edu                              */
/*                                                                              */
/* **************************************************************************** */

#define YYDEBUG 1

#include "structs.h"
#include "hashtable.h"

/* ------------------------------------------------------------------------------------ */

extern void 	exit(int);
extern int 	yylex();
       int 	yyerror(char* e);

extern symbol_t* getLabelRef(char *);
extern symbol_t* getSymbolRef(char *);
extern void 	 handleDataMapDirective(symbol_t *s, int dir, oper_t *arg);

extern int 	yacc_debug;			
extern int 	main_debug;			
extern int 	lineno;

/* ------------------------------------------------------------------------------------ */

int file_line = 0;
int program_line = 0;

extern int 	curr_pc;			/* used when simulating the execution	*/

extern int 	inst_cnt;			/* number of identifiers in the code 	*/
extern inst_t	program[MAX_PROG_SIZE];		/* the sequence of instructions 	*/
extern int	mem_addr;			
extern oper_t 	memory[MAX_MEMORY_SIZE];	/* where the values are stored 		*/

extern int 	 id_cnt;			/* number of identifiers in the code 	*/
extern symbol_t* ids[MAX_IDS];			/* table of identifiers 		*/
						/* each id has the address in the 	*/
						/* memory section of the program	*/

extern int 	 label_cnt;			/* number of labels in the code 	*/
extern symbol_t* labels[MAX_LABELS];		/* table of labels in the code  	*/
						/* each label has the address in the 	*/
						/* code section of the program		*/

extern hashtable* label_hash;
extern hashtable* id_hash;

/* ------------------------------------------------------------------------------------ */
/* Global Variables for helping the paerser						*/
/* ------------------------------------------------------------------------------------ */

inst_t    global_inst;
symbol_t* global_symbol;
oper_t*   global_oper;

int 	inside_data_section;
int 	inside_text_section;



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif

#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
#line 76 "assem.y"
{
  int     i;
  double  d;
  char*   s;
  char    c;
  struct oper_t* op;
  struct symbol_t* sym;
  struct inst_t* ip;
}
/* Line 193 of yacc.c.  */
#line 281 "y.tab.c"
	YYSTYPE;
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 216 of yacc.c.  */
#line 294 "y.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int i)
#else
static int
YYID (i)
    int i;
#endif
{
  return i;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  15
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   248

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  52
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  22
/* YYNRULES -- Number of rules.  */
#define YYNRULES  88
/* YYNRULES -- Number of states.  */
#define YYNSTATES  179

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   305

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    51,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     8,    10,    12,    14,    16,    19,
      21,    24,    27,    30,    32,    37,    42,    47,    52,    54,
      58,    62,    67,    72,    75,    77,    78,    81,    83,    86,
      88,    90,    92,    99,   105,   110,   115,   120,   126,   132,
     138,   144,   152,   160,   170,   176,   180,   184,   187,   191,
     194,   197,   201,   205,   209,   213,   221,   227,   233,   239,
     243,   247,   250,   254,   256,   259,   261,   263,   265,   267,
     269,   274,   276,   278,   280,   282,   284,   286,   288,   290,
     292,   294,   296,   298,   300,   302,   304,   306,   308
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      53,     0,    -1,    54,    -1,    55,    54,    -1,    55,    -1,
      57,    -1,    58,    -1,    56,    -1,    41,    56,    -1,    41,
      -1,    62,    64,    -1,    61,    59,    -1,    60,    59,    -1,
      60,    -1,    68,     6,    69,    41,    -1,    68,     7,    69,
      41,    -1,    68,     8,    69,    41,    -1,    68,    10,    69,
      41,    -1,    41,    -1,     3,     5,    41,    -1,     3,     1,
      41,    -1,     3,     4,    63,    41,    -1,     3,     4,     1,
      41,    -1,    51,    40,    -1,    40,    -1,    -1,    65,    64,
      -1,    65,    -1,    68,    66,    -1,    66,    -1,     1,    -1,
      67,    -1,    69,    35,    69,    71,    69,    41,    -1,    69,
      35,    73,    69,    41,    -1,    69,    35,    69,    41,    -1,
      70,    35,    69,    41,    -1,    69,    35,    70,    41,    -1,
      69,    35,    31,    69,    41,    -1,    69,    35,    26,    69,
      41,    -1,    26,    69,    35,    69,    41,    -1,    48,    69,
      16,    69,    41,    -1,    48,    69,    72,    69,    16,    69,
      41,    -1,    48,    12,    69,    13,    16,    69,    41,    -1,
      48,    12,    69,    72,    69,    13,    16,    69,    41,    -1,
      48,     1,    16,    69,    41,    -1,    16,    69,    41,    -1,
      23,    69,    41,    -1,    16,    41,    -1,    16,     1,    41,
      -1,    49,    41,    -1,    50,    41,    -1,    19,    69,    41,
      -1,    19,     1,    41,    -1,    20,    69,    41,    -1,    20,
       1,    41,    -1,    69,    35,    22,    69,    17,    69,    41,
      -1,    69,    35,    22,    69,    41,    -1,    69,    35,    22,
       1,    41,    -1,    22,    69,    17,    69,    41,    -1,    22,
       1,    41,    -1,    21,    69,    41,    -1,    21,    41,    -1,
      21,     1,    41,    -1,    41,    -1,    36,    18,    -1,    36,
      -1,    37,    -1,    38,    -1,    39,    -1,    40,    -1,    36,
      14,    69,    15,    -1,    24,    -1,    25,    -1,    26,    -1,
      27,    -1,    31,    -1,    32,    -1,    28,    -1,    29,    -1,
      34,    -1,    42,    -1,    43,    -1,    44,    -1,    45,    -1,
      46,    -1,    47,    -1,    30,    -1,    33,    -1,    25,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   105,   105,   108,   109,   112,   113,   114,   117,   118,
     121,   124,   127,   128,   131,   135,   139,   143,   147,   152,
     158,   167,   173,   182,   183,   184,   187,   188,   191,   192,
     193,   199,   221,   228,   234,   240,   245,   250,   256,   262,
     268,   274,   281,   287,   294,   302,   307,   312,   317,   323,
     327,   331,   336,   343,   348,   356,   363,   370,   377,   384,
     391,   396,   401,   408,   415,   452,   460,   468,   476,   484,
     494,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     516,   517,   518,   519,   520,   521,   524,   525,   526
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "SEC_DIR", "TEXT_DIR", "DATA_DIR",
  "WORD_DIR", "BYTE_DIR", "ASCII_DIR", "GLOBAL_DIR", "SKIP_DIR", "END_DIR",
  "LPAREN", "RPAREN", "LBR", "RBR", "GOTO", "COMMA", "COLLON", "PUTPAR",
  "GETPAR", "RETURN", "CALL", "JUMP", "PLUS", "MINUS", "TIMES", "DIV",
  "LOG_AND", "LOG_OR", "LOG_NOT", "BIT_AND", "BIT_OR", "BIT_NOT", "PHI",
  "ATRIB", "ID", "IVAL", "DVAL", "CVAL", "SVAL", "NL", "LT", "GT", "LE",
  "GE", "EQ", "NEQ", "IF", "HALT", "NOP", "','", "$accept", "program",
  "section_list", "section", "empty_section", "text_section",
  "data_section", "data_map_list", "data_map", "data_header",
  "text_header", "header_flags", "code", "inst", "instr_ex", "instr",
  "label", "oper", "array_elem", "bin_oper", "relop", "unary_oper", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,    44
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    52,    53,    54,    54,    55,    55,    55,    56,    56,
      57,    58,    59,    59,    60,    60,    60,    60,    60,    61,
      61,    62,    62,    63,    63,    63,    64,    64,    65,    65,
      65,    66,    67,    67,    67,    67,    67,    67,    67,    67,
      67,    67,    67,    67,    67,    67,    67,    67,    67,    67,
      67,    67,    67,    67,    67,    67,    67,    67,    67,    67,
      67,    67,    67,    67,    68,    69,    69,    69,    69,    69,
      70,    71,    71,    71,    71,    71,    71,    71,    71,    71,
      72,    72,    72,    72,    72,    72,    73,    73,    73
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     1,     1,     1,     1,     2,     1,
       2,     2,     2,     1,     4,     4,     4,     4,     1,     3,
       3,     4,     4,     2,     1,     0,     2,     1,     2,     1,
       1,     1,     6,     5,     4,     4,     4,     5,     5,     5,
       5,     7,     7,     9,     5,     3,     3,     2,     3,     2,
       2,     3,     3,     3,     3,     7,     5,     5,     5,     3,
       3,     2,     3,     1,     2,     1,     1,     1,     1,     1,
       4,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,     0,     9,     0,     2,     4,     7,     5,     6,     0,
       0,     0,     0,     0,     8,     1,     3,     0,    18,    11,
      13,     0,    30,     0,     0,     0,     0,     0,     0,     0,
      65,    66,    67,    68,    69,    63,     0,     0,     0,    10,
       0,    29,    31,     0,     0,     0,    20,     0,    24,     0,
       0,    19,    64,    12,     0,     0,     0,     0,     0,    65,
      47,     0,     0,     0,     0,     0,     0,    61,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    49,    50,    26,
      65,    28,     0,     0,    22,    23,    21,     0,     0,     0,
       0,    48,    45,    52,    51,    54,    53,    62,    60,    59,
       0,    46,     0,     0,     0,     0,     0,    80,    81,    82,
      83,    84,    85,     0,     0,    88,     0,    86,     0,    87,
       0,     0,     0,     0,    14,    15,    16,    17,     0,     0,
      70,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      71,    72,    73,    74,    77,    78,    75,    76,    79,    34,
       0,    36,     0,    35,    58,    39,    44,     0,     0,    40,
       0,    57,     0,    56,    38,    37,     0,    33,     0,     0,
       0,     0,    32,    42,     0,    41,    55,     0,    43
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     3,     4,     5,     6,     7,     8,    19,    20,     9,
      10,    50,    39,    40,    41,    42,    21,    44,    45,   150,
     113,   122
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -35
static const yytype_int16 yypact[] =
{
      12,   145,   -34,     8,   -35,    12,   -35,   -35,   -35,   -25,
      81,   -17,    16,   -14,   -35,   -35,   -35,     5,   -35,   -35,
     -25,    62,   -35,    48,   104,   131,    75,   137,   -18,   -18,
      -4,   -35,   -35,   -35,   -35,   -35,   123,   -12,    14,   -35,
      25,   -35,   -35,   169,    23,    36,   -35,    37,   -35,     3,
      39,   -35,   -35,   -35,   -18,   -18,   -18,   -18,    51,   -35,
     -35,    53,    55,    57,    65,    67,    68,   -35,    84,    85,
     111,    92,   101,   -18,   132,   -18,    -7,   -35,   -35,   -35,
     133,   -35,   190,   -18,   -35,   -35,   -35,   117,   124,   125,
     138,   -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,
     -18,   -35,   -18,   149,   -18,   110,   -18,   -35,   -35,   -35,
     -35,   -35,   -35,   -18,   144,   -35,   -18,   -35,   -18,   -35,
     207,   146,   -18,   152,   -35,   -35,   -35,   -35,   153,   155,
     -35,   156,   162,   -18,   157,   170,   158,    13,   159,   160,
     -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,
     -18,   -35,   161,   -35,   -35,   -35,   -35,   -18,   191,   -35,
     -18,   -35,   -18,   -35,   -35,   -35,   172,   -35,   173,   187,
     181,   183,   -35,   -35,   -18,   -35,   -35,   184,   -35
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
     -35,   -35,   167,   -35,   209,   -35,   -35,   217,   -35,   -35,
     -35,   -35,   200,   -35,   199,   -35,     2,   -23,   163,   -35,
     139,   -35
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -28
static const yytype_int16 yytable[] =
{
      61,    63,    65,    68,    70,    71,    72,     2,    15,   106,
      73,    17,    43,    76,    52,     1,    18,    47,    59,    31,
      32,    33,    34,    52,    46,   -27,    22,    51,   -27,    77,
     162,    87,    88,    89,    90,   107,   108,   109,   110,   111,
     112,    23,    43,    85,    24,    25,    26,    27,    28,    58,
     103,    29,   105,     2,   163,    78,    48,   -25,    82,   120,
     123,    30,    31,    32,    33,    34,    35,    49,    54,    55,
      56,    83,    57,    36,    37,    38,    66,   128,    84,   129,
      86,   131,    22,   134,    59,    31,    32,    33,    34,    60,
     135,   137,    91,   138,    92,   139,    93,    23,    94,   152,
      24,    25,    26,    27,    28,    62,    95,    29,    96,    97,
     158,    59,    31,    32,    33,    34,    67,    30,    31,    32,
      33,    34,    35,   132,    74,    98,    99,   166,   100,    36,
      37,    38,    64,   101,   168,    75,   102,   170,    69,   171,
      59,    31,    32,    33,    34,   136,    11,    73,   104,    12,
      13,   177,   107,   108,   109,   110,   111,   112,   124,    59,
      31,    32,    33,    34,   130,   125,   126,    59,    31,    32,
      33,    34,    16,    59,    31,    32,    33,    34,   157,   127,
      59,    31,    32,    33,    34,    23,   160,   151,    24,    25,
      26,    27,    28,   153,   154,    29,   155,   156,   159,   161,
     164,   165,   167,   174,   169,    80,    31,    32,    33,    34,
      35,    14,   114,   172,   173,   115,   116,    36,    37,    38,
     117,   118,   175,   119,   176,   178,    80,    31,    32,    33,
      34,   140,   141,   142,   143,   144,   145,    53,   146,   147,
      79,   148,    81,     0,   133,   121,     0,     0,   149
};

static const yytype_int16 yycheck[] =
{
      23,    24,    25,    26,    27,    28,    29,    41,     0,    16,
      14,    36,    10,    36,    18,     3,    41,     1,    36,    37,
      38,    39,    40,    18,    41,     0,     1,    41,     3,    41,
      17,    54,    55,    56,    57,    42,    43,    44,    45,    46,
      47,    16,    40,    40,    19,    20,    21,    22,    23,     1,
      73,    26,    75,    41,    41,    41,    40,    41,    35,    82,
      83,    36,    37,    38,    39,    40,    41,    51,     6,     7,
       8,    35,    10,    48,    49,    50,     1,   100,    41,   102,
      41,   104,     1,   106,    36,    37,    38,    39,    40,    41,
     113,   114,    41,   116,    41,   118,    41,    16,    41,   122,
      19,    20,    21,    22,    23,     1,    41,    26,    41,    41,
     133,    36,    37,    38,    39,    40,    41,    36,    37,    38,
      39,    40,    41,    13,     1,    41,    41,   150,    17,    48,
      49,    50,     1,    41,   157,    12,    35,   160,     1,   162,
      36,    37,    38,    39,    40,     1,     1,    14,    16,     4,
       5,   174,    42,    43,    44,    45,    46,    47,    41,    36,
      37,    38,    39,    40,    15,    41,    41,    36,    37,    38,
      39,    40,     5,    36,    37,    38,    39,    40,    16,    41,
      36,    37,    38,    39,    40,    16,    16,    41,    19,    20,
      21,    22,    23,    41,    41,    26,    41,    41,    41,    41,
      41,    41,    41,    16,    13,    36,    37,    38,    39,    40,
      41,     2,    22,    41,    41,    25,    26,    48,    49,    50,
      30,    31,    41,    33,    41,    41,    36,    37,    38,    39,
      40,    24,    25,    26,    27,    28,    29,    20,    31,    32,
      40,    34,    43,    -1,   105,    82,    -1,    -1,    41
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     3,    41,    53,    54,    55,    56,    57,    58,    61,
      62,     1,     4,     5,    56,     0,    54,    36,    41,    59,
      60,    68,     1,    16,    19,    20,    21,    22,    23,    26,
      36,    37,    38,    39,    40,    41,    48,    49,    50,    64,
      65,    66,    67,    68,    69,    70,    41,     1,    40,    51,
      63,    41,    18,    59,     6,     7,     8,    10,     1,    36,
      41,    69,     1,    69,     1,    69,     1,    41,    69,     1,
      69,    69,    69,    14,     1,    12,    69,    41,    41,    64,
      36,    66,    35,    35,    41,    40,    41,    69,    69,    69,
      69,    41,    41,    41,    41,    41,    41,    41,    41,    41,
      17,    41,    35,    69,    16,    69,    16,    42,    43,    44,
      45,    46,    47,    72,    22,    25,    26,    30,    31,    33,
      69,    70,    73,    69,    41,    41,    41,    41,    69,    69,
      15,    69,    13,    72,    69,    69,     1,    69,    69,    69,
      24,    25,    26,    27,    28,    29,    31,    32,    34,    41,
      71,    41,    69,    41,    41,    41,    41,    16,    69,    41,
      16,    41,    17,    41,    41,    41,    69,    41,    69,    13,
      69,    69,    41,    41,    16,    41,    41,    69,    41
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *bottom, yytype_int16 *top)
#else
static void
yy_stack_print (bottom, top)
    yytype_int16 *bottom;
    yytype_int16 *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      fprintf (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      fprintf (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The look-ahead symbol.  */
int yychar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  int yystate;
  int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;
#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  yytype_int16 yyssa[YYINITDEPTH];
  yytype_int16 *yyss = yyssa;
  yytype_int16 *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  YYSTYPE *yyvsp;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     look-ahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to look-ahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 105 "assem.y"
    {  if(yacc_debug) printf(" > YACC: program -> section_list\n"); }
    break;

  case 3:
#line 108 "assem.y"
    { if(yacc_debug) printf(" > YACC: section_list -> section section_list\n"); }
    break;

  case 4:
#line 109 "assem.y"
    { if(yacc_debug) printf(" > YACC: section_list -> section\n"); }
    break;

  case 5:
#line 112 "assem.y"
    { if(yacc_debug) printf(" > YACC: section -> text_section\n"); }
    break;

  case 6:
#line 113 "assem.y"
    { if(yacc_debug) printf(" > YACC: section -> data_section\n"); }
    break;

  case 7:
#line 114 "assem.y"
    { if(yacc_debug) printf(" > YACC: section -> empty_section\n"); }
    break;

  case 8:
#line 117 "assem.y"
    { if(yacc_debug) printf(" > YACC: empty_section -> NL empty_section\n"); }
    break;

  case 9:
#line 118 "assem.y"
    { if(yacc_debug) printf(" > YACC: empty_section -> NL\n"); }
    break;

  case 10:
#line 121 "assem.y"
    { if(yacc_debug) printf(" > YACC: text_section -> section_header code\n"); }
    break;

  case 11:
#line 124 "assem.y"
    { if(yacc_debug) printf(" > YACC: data_section -> data_header data_map_list\n"); }
    break;

  case 12:
#line 127 "assem.y"
    { if(yacc_debug) printf(" > YACC: data_map_list -> data_map data_map_list\n");	}
    break;

  case 13:
#line 128 "assem.y"
    { if(yacc_debug) printf(" > YACC: data_map_list -> data_map\n");		}
    break;

  case 14:
#line 131 "assem.y"
    { 
  					  if(yacc_debug) { printf(" > YACC: data_map -> label .word oper NL\n"); }
  					  handleDataMapDirective((yyvsp[(1) - (4)].sym), WORD_DIR, (yyvsp[(3) - (4)].op));
					}
    break;

  case 15:
#line 135 "assem.y"
    { 
  					  if(yacc_debug) { printf(" > YACC: data_map -> label .byte oper NL\n"); }
  					  handleDataMapDirective((yyvsp[(1) - (4)].sym), BYTE_DIR, (yyvsp[(3) - (4)].op));
					}
    break;

  case 16:
#line 139 "assem.y"
    { 
  					  if(yacc_debug) { printf(" > YACC: data_map -> label .ascii oper NL\n"); }
  					  handleDataMapDirective((yyvsp[(1) - (4)].sym), ASCII_DIR, (yyvsp[(3) - (4)].op));
					}
    break;

  case 17:
#line 143 "assem.y"
    { 
  					  if(yacc_debug) { printf(" > YACC: data_map -> label .skip oper NL\n"); }
  					  handleDataMapDirective((yyvsp[(1) - (4)].sym), SKIP_DIR, (yyvsp[(3) - (4)].op));
					}
    break;

  case 18:
#line 147 "assem.y"
    { 
					  if(yacc_debug) printf(" > YACC: data_map -> NL\n"); 
					}
    break;

  case 19:
#line 152 "assem.y"
    { 
					  if(yacc_debug) printf(" > YACC: data_header -> .section .data\n");  
                                          inside_text_section = 0;
                                          inside_data_section = 1;
					  program_line = 0;
					}
    break;

  case 20:
#line 158 "assem.y"
    {
					  if(yacc_debug) printf(" > YACC: data_header -> .section error\n");  
					  printf(" *** Parsing error: Expecting a \'.data\' token\n");
                                          inside_text_section = 0;
                                          inside_data_section = 1;
					  program_line = 0;
					}
    break;

  case 21:
#line 167 "assem.y"
    { 
					if(yacc_debug) printf(" > YACC: text_header -> .section .text flags\n"); 
                                        inside_text_section = 1;
                                        inside_data_section = 0;
					program_line = 0;
                                }
    break;

  case 22:
#line 173 "assem.y"
    {
					  if(yacc_debug) printf(" > YACC: text_header -> .section error\n"); 
					  printf(" *** Parsing error: Something wrong in the text header declaration.\n");
                                          inside_text_section = 1;
                                          inside_data_section = 0;
					  program_line = 0;
				}
    break;

  case 23:
#line 182 "assem.y"
    { if(yacc_debug) printf(" > YACC: header_flags -> ',' \"string\" \n"); }
    break;

  case 24:
#line 183 "assem.y"
    { if(yacc_debug) printf(" > YACC: header_flags -> \"string\" \n"); }
    break;

  case 25:
#line 184 "assem.y"
    { if(yacc_debug) printf(" > YACC: header_flags -> \n"); }
    break;

  case 26:
#line 187 "assem.y"
    {  if(yacc_debug) printf(" > YACC: inst code (1)\n"); }
    break;

  case 27:
#line 188 "assem.y"
    {  if(yacc_debug) printf(" > YACC: inst code (2)\n"); }
    break;

  case 28:
#line 191 "assem.y"
    { if(yacc_debug) printf(" > YACC: label instr_ex\n"); yyerrok; }
    break;

  case 29:
#line 192 "assem.y"
    { if(yacc_debug) printf(" > YACC: instr_ex\n"); yyerrok; }
    break;

  case 30:
#line 193 "assem.y"
    { if(yacc_debug) printf(" > YACC: error in line %d\n",lineno); 
				  printf(" *** Parsing error: Something wrong in the the instruction in line %d,\n",file_line);
					  yyerrok;
				}
    break;

  case 31:
#line 199 "assem.y"
    { 
/*
                  if(global_inst.type == T_NOP){
		    // clearInstruction(&global_inst);
		    program_line++;
	          } else {
*/
		    program[curr_pc].op1 = global_inst.op1; 
                    program[curr_pc].op2 = global_inst.op2; 
                    program[curr_pc].op3 = global_inst.op3;
                    program[curr_pc].operator = global_inst.operator;
                    program[curr_pc].type = global_inst.type;
                    program[curr_pc].line = global_inst.line;
                    curr_pc++;
		    inst_cnt++;
		    clearInstruction(&global_inst);
		    if(yacc_debug) printf(" > YACC: instr\n");
		    program_line++;
	         /*  } */
		}
    break;

  case 32:
#line 221 "assem.y"
    {
          global_inst.type = T_OPER;
          copyOperand(&global_inst.op1, (oper_t*)(yyvsp[(1) - (6)].op));
          copyOperand(&global_inst.op2, (oper_t*)(yyvsp[(3) - (6)].op));
          copyOperand(&global_inst.op3, (oper_t*)(yyvsp[(5) - (6)].op));
          global_inst.line = program_line;
        }
    break;

  case 33:
#line 228 "assem.y"
    { 
          global_inst.type = T_UNARY;
          copyOperand(&global_inst.op1, (oper_t*)(yyvsp[(1) - (5)].op));
          copyOperand(&global_inst.op2, (oper_t*)(yyvsp[(4) - (5)].op));
          global_inst.line = program_line;
        }
    break;

  case 34:
#line 234 "assem.y"
    {
          global_inst.type = T_COPY;
          copyOperand(&global_inst.op1, (oper_t*)(yyvsp[(1) - (4)].op));
          copyOperand(&global_inst.op2, (oper_t*)(yyvsp[(3) - (4)].op));
          global_inst.line = program_line;
        }
    break;

  case 35:
#line 240 "assem.y"
    {
          global_inst.type = T_MSTORE;
          copyOperand(&global_inst.op3, (oper_t*)(yyvsp[(3) - (4)].op));
          global_inst.line = program_line;
        }
    break;

  case 36:
#line 245 "assem.y"
    {
          global_inst.type = T_MLOAD;
          copyOperand(&global_inst.op3, (oper_t*)(yyvsp[(1) - (4)].op));
          global_inst.line = program_line;
        }
    break;

  case 37:
#line 250 "assem.y"
    {
          global_inst.type = T_ADDRESSOF;
          copyOperand(&global_inst.op1, (oper_t*)(yyvsp[(1) - (5)].op));
          copyOperand(&global_inst.op2, (oper_t*)(yyvsp[(4) - (5)].op));
          global_inst.line = program_line;
	}
    break;

  case 38:
#line 256 "assem.y"
    {
          global_inst.type = T_DEREF;
          copyOperand(&global_inst.op1, (oper_t*)(yyvsp[(1) - (5)].op));
          copyOperand(&global_inst.op2, (oper_t*)(yyvsp[(4) - (5)].op));
          global_inst.line = program_line;
	}
    break;

  case 39:
#line 262 "assem.y"
    {
          global_inst.type = T_PTRASSIGN;
          copyOperand(&global_inst.op1, (oper_t*)(yyvsp[(2) - (5)].op));
          copyOperand(&global_inst.op2, (oper_t*)(yyvsp[(4) - (5)].op));
          global_inst.line = program_line;
	}
    break;

  case 40:
#line 268 "assem.y"
    {
          global_inst.type = T_BOOL_COND;
          copyOperand(&global_inst.op1, (oper_t*)(yyvsp[(2) - (5)].op));
          copyOperand(&global_inst.op2, (oper_t*)(yyvsp[(4) - (5)].op));
          global_inst.line = program_line;
        }
    break;

  case 41:
#line 274 "assem.y"
    {
          global_inst.type = T_COND;
          copyOperand(&global_inst.op1, (oper_t*)(yyvsp[(2) - (7)].op));
          copyOperand(&global_inst.op2, (oper_t*)(yyvsp[(4) - (7)].op));
          copyOperand(&global_inst.op3, (oper_t*)(yyvsp[(6) - (7)].op));
          global_inst.line = program_line;
        }
    break;

  case 42:
#line 281 "assem.y"
    {
          global_inst.type = T_BOOL_COND;
          copyOperand(&global_inst.op1, (oper_t*)(yyvsp[(3) - (7)].op));
          copyOperand(&global_inst.op2, (oper_t*)(yyvsp[(6) - (7)].op));
          global_inst.line = program_line;
        }
    break;

  case 43:
#line 287 "assem.y"
    {
          global_inst.type = T_COND;
          copyOperand(&global_inst.op1, (oper_t*)(yyvsp[(3) - (9)].op));
          copyOperand(&global_inst.op2, (oper_t*)(yyvsp[(5) - (9)].op));
          copyOperand(&global_inst.op3, (oper_t*)(yyvsp[(8) - (9)].op));
          global_inst.line = program_line;
        }
    break;

  case 44:
#line 294 "assem.y"
    {
          global_inst.type = T_GOTO;
          copyOperand(&global_inst.op1, (oper_t*)(yyvsp[(4) - (5)].op));
	  printf(" *** Warn: Invalid predicate in \'if\' instruction in line %d - unconditional GOTO inserted\n",
	   lineno);
          global_inst.line = program_line;
	  yyerrok;
        }
    break;

  case 45:
#line 302 "assem.y"
    {
          global_inst.type = T_GOTO;
          copyOperand(&global_inst.op1, (oper_t*)(yyvsp[(2) - (3)].op));
          global_inst.line = program_line;
        }
    break;

  case 46:
#line 307 "assem.y"
    {
          global_inst.type = T_JUMP;
          copyOperand(&global_inst.op1, (oper_t*)(yyvsp[(2) - (3)].op));
          global_inst.line = program_line;
        }
    break;

  case 47:
#line 312 "assem.y"
    {
          global_inst.type = T_NOP;
	  printf(" *** Warn: Empty GOTO target in line %d - NOP inserted\n",lineno);
          global_inst.line = program_line;
        }
    break;

  case 48:
#line 317 "assem.y"
    {
          global_inst.type = T_NOP;
	  printf(" *** Warn: Incorrect GOTO instruction in line %d - NOP inserted\n",lineno);
          global_inst.line = program_line;
	  yyerrok;
        }
    break;

  case 49:
#line 323 "assem.y"
    {
          global_inst.type = T_HALT;
          global_inst.line = program_line;
        }
    break;

  case 50:
#line 327 "assem.y"
    {
          global_inst.type = T_NOP;
          global_inst.line = program_line;
        }
    break;

  case 51:
#line 331 "assem.y"
    {
          global_inst.type = T_PUTPAR;
          copyOperand(&global_inst.op1, (oper_t*)(yyvsp[(2) - (3)].op));
          global_inst.line = program_line;
        }
    break;

  case 52:
#line 336 "assem.y"
    {
          global_inst.type = T_NOP;
          global_inst.op1.type = O_NULL;
	  printf(" *** Warn: Invalid \'putparam\' instruction in line %d - NOP inserted\n",lineno);
          global_inst.line = program_line;
	  yyerrok;
        }
    break;

  case 53:
#line 343 "assem.y"
    {
          global_inst.type = T_GETPAR;
          copyOperand(&global_inst.op1, (oper_t*)(yyvsp[(2) - (3)].op));
          global_inst.line = program_line;
        }
    break;

  case 54:
#line 348 "assem.y"
    {
          global_inst.type = T_NOP;
          global_inst.op1.type = O_NULL;
	  printf(" *** Warn: Invalid \'getparam\' instruction in line %d - NOP inserted\n",lineno);
          global_inst.line = program_line;
	  yyerrok;
        }
    break;

  case 55:
#line 356 "assem.y"
    {
          global_inst.type = T_CALL;
          copyOperand(&global_inst.op1, (oper_t*)(yyvsp[(1) - (7)].op));
          copyOperand(&global_inst.op2, (oper_t*)(yyvsp[(4) - (7)].op));
          copyOperand(&global_inst.op3, (oper_t*)(yyvsp[(6) - (7)].op));
          global_inst.line = program_line;
        }
    break;

  case 56:
#line 363 "assem.y"
    {
          global_inst.type = T_CALL;
          copyOperand(&global_inst.op1, (oper_t*)(yyvsp[(1) - (5)].op));
          copyOperand(&global_inst.op2, (oper_t*)(yyvsp[(4) - (5)].op));
          global_inst.op3.type = O_NULL;
          global_inst.line = program_line;
        }
    break;

  case 57:
#line 370 "assem.y"
    {
          global_inst.type = T_NOP;
          global_inst.op1.type = O_NULL;
	  printf(" *** Warn: Incorrect CALL instruction in line %d - NOP inserted\n",lineno);
          global_inst.line = program_line;
	  yyerrok;
        }
    break;

  case 58:
#line 377 "assem.y"
    {
          global_inst.type = T_CALL;
          global_inst.op1.type = O_NULL;
          copyOperand(&global_inst.op2, (oper_t*)(yyvsp[(2) - (5)].op));
          copyOperand(&global_inst.op3, (oper_t*)(yyvsp[(4) - (5)].op));
          global_inst.line = program_line;
	}
    break;

  case 59:
#line 384 "assem.y"
    {
          global_inst.type = T_NOP;
          global_inst.op1.type = O_NULL;
	  printf(" *** Warn: Incorrect CALL instruction in line %d - NOP inserted\n",lineno);
          global_inst.line = program_line;
	  yyerrok;
	}
    break;

  case 60:
#line 391 "assem.y"
    {
          global_inst.type = T_RETURN;
          copyOperand(&global_inst.op1, (oper_t*)(yyvsp[(2) - (3)].op));
          global_inst.line = program_line;
        }
    break;

  case 61:
#line 396 "assem.y"
    {
          global_inst.type = T_RETURN;
          global_inst.op1.type = O_NULL;
          global_inst.line = program_line;
	}
    break;

  case 62:
#line 401 "assem.y"
    {
          global_inst.type = T_RETURN;
          global_inst.op1.type = O_NULL;
	  printf(" *** Warn: Incorrect RETURN instruction in line %d - NOP inserted\n",lineno);
          global_inst.line = program_line;
	  yyerrok;
	}
    break;

  case 63:
#line 408 "assem.y"
    {
          global_inst.type = T_NOP;
          global_inst.op1.type = O_NULL;
          global_inst.line = program_line;
	}
    break;

  case 64:
#line 415 "assem.y"
    {
              	  int found; 
		  symbol_t *sym;

		  if(inside_text_section){ 
		    found = 0;
  		    sym = lookupItem(label_hash, &found, (yyvsp[(1) - (2)].s));
		    if(sym != NULL){
		      printf(" *** Error: Label %s in line %d multiply defined. Previous definition ignored.\n",(yyvsp[(1) - (2)].s),file_line);
		    }   
              	    sym = getLabelRef((yyvsp[(1) - (2)].s));
		    global_symbol = sym;
                    sym->address = program_line;
		    if(yacc_debug){
		      printf(" > YACC: Setting label %s to program counter %d\n",(yyvsp[(1) - (2)].s),program_line);
 		    }
		    (yyval.sym) = (struct symbol_t*)sym;
		  } /* --- end of inside text section --- */

		  if(inside_data_section){ 
		    found = 0;
  		    sym = lookupItem(id_hash, &found, (yyvsp[(1) - (2)].s));
		    if(sym != NULL){
		      printf(" *** Error: Variable %s in line %d multiply defined. Previous definition ignored.\n",(yyvsp[(1) - (2)].s),file_line);
		    }   
              	    sym = getSymbolRef((yyvsp[(1) - (2)].s));
		    global_symbol = sym;
  		    sym->address = -1;
		    if(yacc_debug){
		      printf(" > YACC: Mapping variable %s to address %d and size %d\n",sym->tag, sym->address, sym->size);
 		    }
		    (yyval.sym) = (struct symbol_t*)sym;
		    sym = NULL;
		  } /* --- end of inside data section --- */
        	}
    break;

  case 65:
#line 452 "assem.y"
    { oper_t *op;
		  if(yacc_debug){
		    printf(" > YACC: Debug ID = %s\n",(yyvsp[(1) - (1)].s));
		  }
		  op = createStringValOperand((yyvsp[(1) - (1)].s));
		  (yyval.op) = (struct oper_t*)op;
		  global_oper = op;
		}
    break;

  case 66:
#line 460 "assem.y"
    { oper_t *op;
		  if(yacc_debug){
		    printf(" > YACC: Debug IVAL = %d\n",(yyvsp[(1) - (1)].i));
		  }
		  op = createIntegerValOperand((yyvsp[(1) - (1)].i));
		  (yyval.op) = (struct oper_t*)op;
		  global_oper = op;
		}
    break;

  case 67:
#line 468 "assem.y"
    { oper_t *op;
		  if(yacc_debug){
		    printf(" > YACC: Debug DVAL = %f\n",(yyvsp[(1) - (1)].d));
		  }
		  op = createDoubleValOperand((yyvsp[(1) - (1)].d));
		  (yyval.op) = (struct oper_t*)op;
		  global_oper = op;
		}
    break;

  case 68:
#line 476 "assem.y"
    { oper_t *op;
		  if(yacc_debug){
		    printf(" > YACC: Debug CVAL = %c\n",(yyvsp[(1) - (1)].c));
		  }
		  op = createCharValOperand((yyvsp[(1) - (1)].c));
		  (yyval.op) = (struct oper_t*)op;
		  global_oper = op;
		}
    break;

  case 69:
#line 484 "assem.y"
    { oper_t *op;
		  if(yacc_debug){
		    printf(" > YACC: Debug SVAL = \"%s\"\n",(yyvsp[(1) - (1)].s));
		  }
		  op = createStringValOperand((yyvsp[(1) - (1)].s));
		  (yyval.op) = (struct oper_t*)op;
		  global_oper = op;
		}
    break;

  case 70:
#line 494 "assem.y"
    {
	        oper_t *tmp;
		if(yacc_debug){
		  printf(" > YACC: Debug array_elem : ID [ oper ]\n");
		}
	        tmp = (oper_t*)createStringValOperand((yyvsp[(1) - (4)].s));
                copyOperand(&global_inst.op1, tmp);
                copyOperand(&global_inst.op2, (oper_t*)(yyvsp[(3) - (4)].op));
             }
    break;

  case 71:
#line 505 "assem.y"
    { global_inst.operator = PLUS;	}
    break;

  case 72:
#line 506 "assem.y"
    { global_inst.operator = MINUS;	}
    break;

  case 73:
#line 507 "assem.y"
    { global_inst.operator = TIMES;	}
    break;

  case 74:
#line 508 "assem.y"
    { global_inst.operator = DIV;	}
    break;

  case 75:
#line 509 "assem.y"
    { global_inst.operator = BIT_AND;	}
    break;

  case 76:
#line 510 "assem.y"
    { global_inst.operator = BIT_OR;	}
    break;

  case 77:
#line 511 "assem.y"
    { global_inst.operator = LOG_AND;	}
    break;

  case 78:
#line 512 "assem.y"
    { global_inst.operator = LOG_OR;	}
    break;

  case 79:
#line 513 "assem.y"
    { global_inst.operator = PHI;	}
    break;

  case 80:
#line 516 "assem.y"
    { global_inst.operator = LT;	}
    break;

  case 81:
#line 517 "assem.y"
    { global_inst.operator = GT;	}
    break;

  case 82:
#line 518 "assem.y"
    { global_inst.operator = LE;	}
    break;

  case 83:
#line 519 "assem.y"
    { global_inst.operator = GE;	}
    break;

  case 84:
#line 520 "assem.y"
    { global_inst.operator = EQ;	}
    break;

  case 85:
#line 521 "assem.y"
    { global_inst.operator = NEQ;	}
    break;

  case 86:
#line 524 "assem.y"
    { global_inst.operator = LOG_NOT;	}
    break;

  case 87:
#line 525 "assem.y"
    { global_inst.operator = BIT_NOT;	}
    break;

  case 88:
#line 526 "assem.y"
    { global_inst.operator = MINUS;	}
    break;


/* Line 1267 of yacc.c.  */
#line 2386 "y.tab.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEOF && yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


#line 529 "assem.y"


#include <stdio.h>

/* ----------------------------------------------------------------------- */
int yyerror(char *s) {

  /* 
  fflush(stdout);
  fprintf(stderr, " *** Error(s) encountered while processing input file in line %d\n",lineno+1);
  */
}

/* ----------------------------------------------------------------------- */
/* Assumes valid hex characters */
void hextodec(char *resul, char *orig) {
   int x = 0;
   /* hex string ends with h/H */
   while((*orig != 'h') && (*orig != 'H')){
      x = x << 4;
      *orig |= 32;                /* convert to lower case */
      if(*orig >= 'a')
          x |= *orig -'a' + 10;
      else
          x |= *orig - '0';
      orig++;
   }
   sprintf(resul, "%d", x);
}

/* ----------------------------------------------------------------------- */
/* --- Assumes valid oct characters --- */
void octtodec(char *resul, char *orig) {
   int x = 0;
   /* oct string ends with o/O */
   while((*orig != 'o') && (*orig != 'O')){
      x = x << 3;
      x |= *orig - '0';
      orig++;
   }
   sprintf(resul, "%d", x);
}

/* ----------------------------------------------------------------------- */
/* --- Assumes valid bin characters --- */
void bintodec(char *resul, char *orig) {
   int x = 0;
   /* bin string ends with b/B */
   while((*orig != 'b') && (*orig != 'B')){
      x = x << 1;
      x |= *orig - '0';
      orig++;
   }
   sprintf(resul, "%d", x);
}

/* ----------------------------------------------------------------------- */
void handleDataMapDirective(symbol_t *s, int dir, oper_t *arg){
  oper_t *op; 
  symbol_t *sym;

  sym = global_symbol;
  op = global_oper;
  switch(dir){
    case WORD_DIR:
      if(op->type == O_INTEGER){ 
        sym->size = 1;
        sym->address = mem_addr;
        mem_addr += 1;
        sym->initvalue = arg;
      } else {
        printf(" *** Error: Invalid (non-integer) value for .word directive of variable %s\n",sym->tag);
      }
      break;
    case BYTE_DIR:
      if(op->type == O_CHAR){ 
        sym->size = 1;
        sym->address = mem_addr;
        mem_addr += 1;
        sym->initvalue = arg;
      } else {
        printf(" *** Error: Invalid (non-char) value for .byte directive of variable %s\n",sym->tag);
      }
      break;
    case SKIP_DIR:
      if(op->type == O_INTEGER){
        sym->size = op->u.ival;
        sym->address = mem_addr;
        mem_addr += op->u.ival;
        sym->initvalue = NULL;
      } else {
        printf(" *** Error: Invalid (non-integer) value for .skip directive of variable %s\n", sym->tag);
      }
      break;
    case ASCII_DIR:
      if(op->type == O_STRING){
        sym->size = strlen(op->u.sval);
        sym->address = mem_addr;
        mem_addr += strlen(op->u.sval)+1;
        sym->initvalue = arg;
      } else {
        printf(" *** Error: Invalid (non-string) value for .ascii directive of variable %s\n", 
	  sym->tag);
      }
      break;
    default:
      break;
  } /* end of switch */

/*
  if(yacc_debug){
    printf(" > YACC: setting the initial value of %s at mem address %d to ",sym->tag,sym->address);
    printOperand(sym->initvalue);
    printf("\n");
  }
*/

}
/* ----------------------------------------------------------------------- */

